package example;

import org.eclipse.swt.*;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.widgets.*;

public class ShellModifiedTest
{
	private static Display display;
	private static Shell shell;
    private static String MESSAGE = "У Вас имеются несохраненные данные."
    		                        + "\nЗавершить работу?";    
    private void createMenu()
    {
		Menu bar = new Menu (shell, SWT.BAR);
		shell.setMenuBar (bar);
		MenuItem fileItem = new MenuItem (bar, SWT.CASCADE);
		fileItem.setText ("Файл");
		Menu fileMenu = new Menu (shell, SWT.DROP_DOWN);
		fileItem.setMenu (fileMenu);
		MenuItem saveItem = new MenuItem (fileMenu, SWT.PUSH);
		saveItem.setText ("Сохранить\tCtrl+S");
		saveItem.setAccelerator (SWT.MOD1 + 'S');
		saveItem.addListener (SWT.Selection, new Listener() {
			@Override
			public void handleEvent(Event event) {
				shell.setModified (false);
			}
		});
		MenuItem exitItem =  new MenuItem (fileMenu, SWT.PUSH);
		exitItem.setText ("Выход\tCtrl+Q");
		exitItem.setAccelerator (SWT.MOD1 + 'Q');
		exitItem.addListener (SWT.Selection, new Listener() {
			@Override
			public void handleEvent(Event event) {
				shell.close ();
			}
		});
    }
	public ShellModifiedTest()
	{
		shell.setText ("Контроль состояния окна");
		// Создание меню
		createMenu();
		int style = SWT.H_SCROLL | SWT.V_SCROLL | SWT.BORDER;
		Text text = new Text (shell, style);
		text.addListener (SWT.Modify, new Listener() {
			@Override
			public void handleEvent(Event event) {
				shell.setModified (true);
			}
		});
		text.setText("Тестовая строка для изменения состояния окна.");
		
		shell.setLayout (new FillLayout());
	}
	public static void main(String[] args)
	{
		display = new Display();
		shell = new Shell(display);
		new ShellModifiedTest();
		shell.open ();
		shell.addListener (SWT.Close, new Listener() {
			@Override
			public void handleEvent(Event event) {
				if (shell.getModified()) {
					int style = SWT.PRIMARY_MODAL | SWT.OK | SWT.CANCEL;
					MessageBox box = new MessageBox (shell, style);
					box.setText (shell.getText ());
					box.setMessage (MESSAGE);
					event.doit = box.open () == SWT.OK;
				}
			}
		});
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep ();
		}
		display.dispose ();
	}
}
